/*******************************************************************************
 *	@file			DLGraph.h
 *	@brief			DirectX Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			21-Apr-2010(Wed)
 ******************************************************************************/

#ifndef	__DLGRAPH_INCLUDE__
#define	__DLGRAPH_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

#define SetTextureColorStage( dev, i, arg1, op, arg2 )			\
		dev->SetTextureStageState( i, D3DTSS_COLOROP, op );		\
		dev->SetTextureStageState( i, D3DTSS_COLORARG1, arg1 );	\
		dev->SetTextureStageState( i, D3DTSS_COLORARG2, arg2 );

#define SetTextureAlphaStage( dev, i, arg1, op, arg2 )			\
		dev->SetTextureStageState( i, D3DTSS_ALPHAOP, op );		\
		dev->SetTextureStageState( i, D3DTSS_ALPHAARG1, arg1 );	\
		dev->SetTextureStageState( i, D3DTSS_ALPHAARG2, arg2 );

#define	FVFTEX_MAX			8

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		ED3DDRAW			DLGraph.h		"DLGraph.h"
 *	@brief		`
 ******************************************************************************/
enum ED3DDRAW
{
	ED3DDRAW_NULL			= 0,												//!< Ȃ
	ED3DDRAW_ON,																//!< `悷
	ED3DDRAW_OFF,																//!< `悵Ȃ

	ED3DDRAW_MAX,
};

/*******************************************************************************
 *	@enum		ED3DSTATE			DLGraph.h		"DLGraph.h"
 *	@brief		Xe[g
 ******************************************************************************/
enum ED3DSTATE
{
	ED3DSTATE_NORMAL,															//!< ʏ
	ED3DSTATE_ADD,																//!< Z
	ED3DSTATE_SUB,																//!< Z
	ED3DSTATE_SUBTRACT		= ED3DSTATE_SUB,
	ED3DSTATE_MUL,																//!< Z
	ED3DSTATE_MULTIPLY		= ED3DSTATE_MUL,
	ED3DSTATE_SCR,																//!< XN[
	ED3DSTATE_SCREEN		= ED3DSTATE_SCR,
	ED3DSTATE_CMPD,																//!< riÁj
	ED3DSTATE_DARKEN		= ED3DSTATE_CMPD,
	ED3DSTATE_CMPL,																//!< rij
	ED3DSTATE_LIGHTEN		= ED3DSTATE_CMPL,
	ED3DSTATE_EXC,																//!< O
	ED3DSTATE_EXCLUSION		= ED3DSTATE_EXC,

	ED3DSTATE_MAX,
};

/*******************************************************************************
 *	@enum		ED3DTEX			DLGraph.h		"DLGraph.h"
 *	@brief		eNX`
 ******************************************************************************/
enum ED3DTEX
{
	ED3DTEX_NULL			= 0,												//!< Ȃ
	ED3DTEX_TEXTURE,															//!< eNX`
	ED3DTEX_FILE,																//!< t@C
	ED3DTEX_MEMORY,																//!< 
	ED3DTEX_MOVIE,																//!< [r[

	ED3DTEX_MAX,
};

// \̒`-------------------------------------------------------------------
/*******************************************************************************
*	@struct		SADAPTER		DLGraph.h		"DLGraph.h"
*	@brief		Adapter\
******************************************************************************/
struct SADAPTER
{
	D3DADAPTER_IDENTIFIER9	m_D3DIdent;
	D3DCAPS9				m_D3DCaps[D3DDEVTYPE_NULLREF];
	HMONITOR				m_hMonitor;
	D3DDISPLAYMODE			m_D3DMode;
	BOOL					m_bDeviceType[2];									//!< 0:EChE[h/1:tXN[[h
	BOOL					m_bStencil[2];										//!< 0:fBXvCtH[}bg/1:_O^[Qbg
	D3DFORMAT				m_D3DStencil;

	D3DMULTISAMPLE_TYPE		m_D3DMulti;
	DWORD					m_Quality;
};

/*******************************************************************************
 *	@struct		SDLGRAPH		DLGraph.h		"DLGraph.h"
 *	@brief		Graphics\
 ******************************************************************************/
struct SDLGRAPH
{
	SDLGRAPH()
		: m_nWidth( 0 )
		, m_nHeight( 0 )
		, m_bMode( FALSE )
	{
	}

	//
	int						m_nWidth;											//!< 
	int						m_nHeight;											//!< 
	BOOL					m_bMode;											//!< [h
};

/*******************************************************************************
 *	@struct		SD3DFVFTEX		DLGraph.h		"DLGraph.h"
 *	@brief		eNX`W\
 ******************************************************************************/
struct SD3DFVFTEX
{
	float					tu;													//!< eNX`W
	float					tv;													//!< eNX`W
};

/*******************************************************************************
 *	@struct		SD3DVERTEX		DLGraph.h		"DLGraph.h"
 *	@brief		_\
 ******************************************************************************/
struct SD3DVERTEX
{
	float					x, y, z;											//!< ʒuW
	float					rhw;												//!< ̋t
	D3DCOLOR				color;												//!< _F
	SD3DFVFTEX				tex[ FVFTEX_MAX ];									//!< eNX`W\
};

/*******************************************************************************
 *	@struct		SD3DTEXTURE		DLGraph.h		"DLGraph.h"
 *	@brief		eNX`\
 ******************************************************************************/
struct SD3DTEXTURE
{
	SD3DTEXTURE()
		: m_lpD3DTex( NULL )
		, m_D3DDesc()

		, m_eTex( ED3DTEX_NULL )

		, m_szName()
		, m_byData( NULL )
		, m_nSize( 0 )
	{
	}

	//
	LPDIRECT3DTEXTURE9		m_lpD3DTex;											//!< eNX`
	D3DSURFACE_DESC			m_D3DDesc;											//!< \[X

	ED3DTEX					m_eTex;												//!< eNX`tO

	LPCSTR					m_szName;											//!< O
	BYTE*					m_byData;											//!< f[^
	int						m_nSize;											//!< f[^TCY
};

/*******************************************************************************
 *	@struct		SD3DFONT		DLGraph.h		"DLGraph.h"
 *	@brief		tHg\
 ******************************************************************************/
struct SD3DFONT
{
	SD3DFONT()
		: m_lpD3DFont( NULL )

		, m_szName()
		, m_nHeight( 0 )
	{
	}

	//
	LPD3DXFONT				m_lpD3DFont;										//!< tHg

	LPCSTR					m_szName;											//!< O
	int						m_nHeight;											//!< 
};

/*******************************************************************************
 *	@struct		SD3DDATA		DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNgf[^\
 ******************************************************************************/
struct SD3DDATA
{
	SD3DDATA()
		: m_nDataMax( 0 )
		, m_pData( NULL )
	{
	}

	//
	int						m_nDataMax;											//!< f[^
	SD3DVERTEX*				m_pData;											//!< f[^
};

/*******************************************************************************
 *	@struct		SD3DTEXT		DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNgeLXg\
 ******************************************************************************/
struct SD3DTEXT
{
	SD3DTEXT()
		: m_reRect()
		, m_dwColor( 0x00000000 )
		, m_szStr()
	{
	}

	//
	RECT					m_reRect;											//!< \`
	DWORD					m_dwColor;											//!< \F

	LPSTR					m_szStr;											//!< iAhX̂݁j
};

/*******************************************************************************
*	@struct		SD3DMODEL		DLGraph.h		"DLGraph.h"
*	@brief		bV\
******************************************************************************/
struct SD3DMESH
{
	SD3DMESH()
		: m_pMesh(NULL)

		, m_szName()
	{
	}

	//
	ID3DXMesh*				m_pMesh;											//!< bV

	LPCSTR					m_szName;											//!< O
};

/*******************************************************************************
 *	@struct		SD3DMODEL		DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNgf\
 ******************************************************************************/
struct SD3DMODEL
{
	SD3DMODEL()
		: m_D3DMate()
		, m_nMesh( -1 )
		, m_D3DMatrix()
	{
		D3DXMatrixIdentity(&m_D3DMatrix);
	}

	//
	D3DMATERIAL9			m_D3DMate;											//!< }eA
	int						m_nMesh;											//!< bVԍ
	D3DXMATRIX				m_D3DMatrix;										//!< Wn
};

/*******************************************************************************
 *	@struct		SD3DOBJECT		DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNg\
 ******************************************************************************/
struct SD3DOBJECT
{
	SD3DOBJECT()
		: m_bUsed( FALSE )
		, m_eObj( EOBJECT_NULL )
		, m_nPrio( -1 )
		, m_eState( ED3DSTATE_NORMAL )
		, m_eDraw( ED3DDRAW_NULL )
		, m_pPrev( NULL )
		, m_pNext( NULL )
	{
		for( int i = 0; i < FVFTEX_MAX; i++ )
			m_nMatNum[ i ] = -1;
	}

	// {
	BOOL					m_bUsed;											//!< gptO
	EOBJECT					m_eObj;												//!< IuWFNg
	int						m_nPrio;											//!< `vCIeB
	// f
	int						m_nMatNum[ FVFTEX_MAX ];							//!< fޔԍ
	// 
	ED3DSTATE				m_eState;											//!< Xe[gtO
	// `
	ED3DDRAW				m_eDraw;											//!< `tO
	// Kw\
	SD3DOBJECT*				m_pPrev;											//!< O
	SD3DOBJECT*				m_pNext;											//!< 

	// ėpf[^
	void*					m_pObj;												//!< ėpf[^
};

/*******************************************************************************
*	@struct		SD3DLIGHT		DLGraph.h		"DLGraph.h"
*	@brief		Cg\
******************************************************************************/
struct SD3DLIGHT
{
	SD3DLIGHT()
		: m_bUsed( FALSE )
		, m_Light()
	{
		::ZeroMemory( &m_Light, sizeof(D3DLIGHT9) );
	}

	BOOL					m_bUsed;											//!< gptO
	D3DLIGHT9				m_Light;											//!< CgvpeB
};

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@struct		CD3DTable		DLGraph.h		"DLGraph.h"
 *	@brief		e[uǗNX
 ******************************************************************************/
class CD3DTable
{
public:
	CD3DTable( int nPrio,
			   SD3DOBJECT* pObj )
		: m_nPrio( nPrio )
		, m_pObj( pObj )
	{
	}

	// rZq
	bool operator<( const CD3DTable& n ) const
	{
		return m_nPrio < n.m_nPrio;
	}

	int						m_nPrio;
	SD3DOBJECT*				m_pObj;
};

/*******************************************************************************
 *	@class		CDLGraph		DLGraph.h			"DLGraph.h"
 *	@brief		CDLGraphNX
 ******************************************************************************/
class CDLGraph
{
// 萔`---------------------------------------------------------------------
private:
protected:
public:
	static const int TEXTURE_MAX	= 4096;										//!< eNX`
	static const int FONT_MAX		= 1024;										//!< tHg
	static const int OBJECT_MAX		= 65536;									//!< IuWFNg
	static const int LIGHT_MAX		= 8;										//!< Cg
	static const int MESH_MAX		= 256;										//!< bV\

// o֐-------------------------------------------------------------------
private:
	static int ( CDLGraph::*StepDel[ EOBJECT_GRAPHEND - EOBJECT_GRAPHSTART ] )( const int& nNum );
	static int ( CDLGraph::*StepDraw[ EOBJECT_GRAPHEND - EOBJECT_GRAPHSTART ] )( SD3DOBJECT* pObj );

	BOOL SetViewPort( const int& nWidth,
					  const int& nHeight );										//!< r[|[g̐ݒ
	BOOL DeviceRestore( const HRESULT& hRes );									//!< foCX̕

	void Cleanup( void );														//!< \[X
	void Reconstruct( void );													//!< č\z

	// o^
	void EntryState( void );													//!< Xe[g̓o^

	// fލēǂݍ
	int ReloadTex(SD3DTEXTURE &vTex);											//!< eNX`ēǂݍ
	int ReloadBmp(SD3DTEXTURE &vTex);											//!< 摜ēǂݍ
	int ReloadMem(SD3DTEXTURE &vTex);											//!< ēǂݍ
	int ReloadFont(SD3DFONT &vFont);											//!< tHgč쐬

	// IuWFNg폜
	int DelRect( const int& nNum );												//!< `폜
	int DelVertex( const int& nNum );											//!< ʍ폜
	int DelText( const int& nNum );												//!< eLXg폜
	int DelModel(const int& nNum);												//!< f폜

	// IuWFNg`
	int DrawPrimitiveUP( SD3DOBJECT* pObj );									//!< v~eBu`
	int DrawText( SD3DOBJECT* pObj );											//!< eLXg`
	int DrawModel(SD3DOBJECT *pObj);											//!< f`

protected:
public:
	CDLGraph( void );
	~CDLGraph( void );

	void SetGraph( const SDLGRAPH& SGraph );									//!< ZbgAbv\̐ݒ

	int CheckDevice(void);														//!< foCX̊mF

	int Init(const HWND& hWnd);													//!< 
	int Init( const HWND& hWnd,
			  const int& nWidth,
			  const int& nHeight,
			  const BOOL& bMode );												//!< 
	int End( void );															//!< I

	int Update( void );															//!< ʍXV

	int ChangeDisplay( const int& nPosX,
					   const int& nPosY,
					   const int& nWidth,
					   const int& nHeight,
					   const BOOL& bMode );										//!< ʐ؂ւ
	int SetDLShow( void* pDLShow );

	const LPDIRECT3D9& GetD3DObject( void ){ return m_lpD3D; }					//!< D3D IuWFNg擾
	const LPDIRECT3DDEVICE9& GetD3DDevice( void ){ return m_lpD3DDev; }			//!< D3D foCX擾

	// Wnݒ
	D3DMATRIX* SetViewMatrix(
		const D3DXVECTOR3& vEye,
		const D3DXVECTOR3& vAt,
		const D3DXVECTOR3& vUp);												//!< r[Wnݒ
	D3DMATRIX* SetPerspectiveMatrix(
		const float& fFovy,
		const float& fAspect,
		const float& fZn,
		const float& fZf );														//!< ˉeWnݒ

	// ڊ
	SD3DTEXTURE* GetTexture( const int& nNum );									//!< eNX`擾
	SD3DFONT* GetFont( const int& nNum );										//!< tHg擾
	SD3DOBJECT* GetObject( const int& nNum );									//!< IuWFNg擾
	SD3DLIGHT* GetLight(const int& nNum);										//!< Cg擾
	SD3DMESH* GetMesh(const int& nNum);											//!< bV擾

	// fޓǂݍ
	int LoadTex( const LPBYTE& lpBuf,
				 const int& nSize,
				 const int& nWidth,
				 const int& nHeight );											//!< eNX`̐VK쐬
	int LoadBmp( const LPSTR& szName );											//!< 摜ǂݍ
	int LoadMem( const LPBYTE& lpBuf,
				 const int& nSize );											//!< ǂݍ
	int LoadFont( const LPSTR& szName,
				  const int& nHeight );											//!< tHg쐬
	int LoadMesh(const LPSTR& szName);											//!< bV쐬

	// fމ
	int RemoveTex( const int& nNum );											//!< eNX`
	int RemoveBmp( const int& nNum );											//!< 摜
	int RemoveMem( const int& nNum );											//!< 
	int RemoveFont(const int& nNum);											//!< tHg
	int RemoveMesh(const int& nNum);											//!< bV
	int RemoveALL(void);														//!< fޑS

	// IuWFNgǉ
	int AddRect( const int& nPrio,
				 const int (&nMatNum)[ FVFTEX_MAX ],
				 const ED3DDRAW& eDraw,
				 const ED3DSTATE& eState,
				 const RECT& rcRect,
				 const int& nColor );											//!< `ǉ
	int AddVertex( const int& nPrio,
				   const int (&nMatNum)[ FVFTEX_MAX ],
				   const ED3DDRAW& eDraw,
				   const ED3DSTATE& eState,
				   const int& nVertex,
				   const SD3DVERTEX* SVertex );									//!< ʒǉ
	int AddText( const int& nPrio,
				 const int (&nMatNum)[ FVFTEX_MAX ],
				 const ED3DDRAW& eDraw,
				 const RECT& rcRect,
				 const int& nColor,
				 const LPSTR& lpStr );											//!< eLXgǉ
	int AddModel(
		const int& nPrio,
		const int(&nMatNum)[FVFTEX_MAX],
		const ED3DDRAW& eDraw);													//!< fǉ

	int AddLight(const D3DLIGHTTYPE& eType,
				 const D3DCOLORVALUE& diffuse,
				 const D3DCOLORVALUE& specular,
				 const D3DCOLORVALUE& ambient,
				 const D3DXVECTOR3& direction);									//!< Cgǉ

	// IuWFNg폜
	int Del( const int& nNum );													//!< IuWFNg폜
	int DelALL( void );															//!< IuWFNgS폜

	// Kw\
	int Connect( const int& nNum1,
				 const int& nNum2 );											//!< IuWFNgm̐ڑ
	int Disconnect( const int& nNum );											//!< IuWFNgm̐ؒf

// oϐ-------------------------------------------------------------------
private:
	std::vector<SADAPTER>	m_vAdapter;											//!< A_v^\

	LPDIRECT3D9				m_lpD3D;											//!< Direct3D IuWFNg
	LPDIRECT3DDEVICE9		m_lpD3DDev;											//!< Direct3D foCX

	void*					m_pDLShow;											//!< DirectX Show

	HWND					m_hWnd;												//!< EChEnh
	SDLGRAPH				m_SGraph;											//!< ZbgAbv\
	D3DPRESENT_PARAMETERS	m_D3DPP;											//!< foCX\
	D3DVIEWPORT9			m_D3DVP;											//!< r[|[g\

	// Xe[g
	std::vector<LPDIRECT3DSTATEBLOCK9>	m_vState;								//!< Xe[gubN

	// e[u
	std::multiset<CD3DTable>	m_vTable;										//!< `e[u

	// IuWFNg
	std::vector<SD3DTEXTURE>	m_vD3DTex;										//!< eNX`\
	std::vector<SD3DFONT>	m_vD3DFont;											//!< tHg\
	std::vector<SD3DOBJECT>	m_vD3DObj;											//!< IuWFNg\
	std::vector<SD3DLIGHT>	m_vD3DLight;										//!< Cg\
	std::vector<SD3DMESH>	m_vD3DMesh;											//!< bV\

	D3DXMATRIX				m_D3DMatView;										//!< r[Wn
	D3DXMATRIX				m_D3DMatProj;										//!< ˉeWn


protected:
public:

};

// OO[oϐ-----------------------------------------------------------

// O֐vg^Cv錾-----------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLGRAPH_INCLUDE__
